#! /usr/bin/perl
# Copyright (C) 2001-2002 by <Christian.Queinnec@lip6.fr>
# $Id: foge-sample.cgi,v 1.3 2002/12/27 12:51:46 queinnec Exp $

use CGI qw(:standard :html3);
use CGI::Carp qw(fatalsToBrowser);
require "FOGE.pl";

# Define some new questions (questions.pl lists questions in French:)

my @Colors = ('red', 'blue', 'green', 'purple', 'yellow');

FOGE::add_questions({
    'hasComputer' => {
        'label' => 'Do you have a computer?',
        'kind' => 'menu',
        'choice' => ['yes', 'no']},
    'hasConnection' => {
        'label' => 'Do you have an Internet connection?',
        'choice' => ['maybe', 'so-so', "I dunno"],
        'kind' => 'checkbox'},
    'chosenColor' => {
        'label' => "What's your favorite color?",
        'kind' => 'scroll_plus_other',
        'choice' => \@Colors,
        'initial' => 'blue' },
    'Comment' => {
        'label' => "What are you thinking right now?",
        'kind' => 'textarea',
        'rows' => 4,
        'columns' => 20,
        'initial' => "to something"}
});

# Define a first section with two questions

my @questions1 = (
    {'id' => 'hasComputer', 'mandatory' => 1},
    {'id' => 'hasConnection', },
);
my $section1 = {
    'title' => "You", 
    'table' => 'foge_you',
    'questions' => \@questions1,
    'bof' => 1,
};

# Define a second section.

my @questions2 = (
    {'id' => 'chosenColor'},
    {'id' => 'Comment', 'mandatory' => 0},
                  );
my $section2 = {
    'title' => 'Colors',
    'prologue' => "In this section, you will asked for your favorite color.",
    'epilogue' => "Whatever you chose will be registered!",
    'table' => 'foge_color',
    'questions' => \@questions2,
    'mandatory' => 1,
};

# Define the whole form:

my @theSections = (
     $section1,
     $section2,
);
$forms = {
    'title'   => "FOGE Sample",
    'css'     => "t.css",
    'author'     => "Christian.Queinnec@lip6.fr",
    'enquiry' => 'foge_answer',
    'introduction' => "
This CGI form is a running example for FOGE. Fill it, submit it, 
then look at the <a href=\"foge-sample.cgi/see\">statistical results</a>.
<p> Mandatory questions are marked with a red star.
",
    'conclusion'   => "This form is run by FOGE (and Perl and CGI).",
    'ipMask'       => '.*', # only accepted IP number
    'submit'       => "Register my choices!",
    'sets' => \@theSections,
    'acknowledgment' => 'Merci pour votre participation',
    'pageFooter' => '<br><tt>
$Id: foge-sample.cgi,v 1.3 2002/12/27 12:51:46 queinnec Exp $ 
</tt><br>
<a href="mailto:Christian.Queinnec@lip6.fr">Remarks?</a>&nbsp;&nbsp;&nbsp;
',
    # Time management
    #'formEndTime'   => $formEndTime,
    #'statStartTime' => $statStartTime,
    # SQL data base to be used:
    'dbName'         => 'dbi:Pg:dbname=foge host=localhost',
    'dbReaderName'   => 'foger',
    'dbReaderPW'     => '2002r',
    'dbWriterName'   => 'fogew',
    'dbWriterPW'     => '2002w',
    # Vote key management:
    #'dbKeyTable'     => 'finsemestre_key',
    #'keyName'        => 'finsemestre_key', # dbKeyTable by default
    #'keyPrologue'    => "<center><p>",
    #'keyEpilogue'    => "</center></p>",
    # URL password (Statistics may only be seen before being public 
    # if knowing this password
    #'URLpw' => 'IYFV5',
    'year'  =>  2002,
};

# Handle GET or POST requests:
#   http://.../sample.cgi                       will serve the form
#   http://.../sample.cgi/anotherSecretePW/see  will serve the statistics
#   perl ./sample.cgi 'action=genererTablesEnvoyer' > tables.sql
#                      will generate the SQL tables.

FOGE::default_main($forms);

1;

# end of foge-sample.cgi
