#! /usr/bin/perl
# Copyright (C) 2001-2002 by <Christian.Queinnec@lip6.fr>
# $Id: questions.pl,v 1.5 2003/01/07 19:07:29 queinnec Exp $
# GPL version 2.

package FOGE;

# {{{ Choices
# Possible choices. These are arrays of strings or numbers. They will
# be displayed as menus. Additional choices may be specified 

@Sexs = ("M", "F");
@YesNo = ("Oui", "Non");
@YesNoBof = ($bof, "Oui", "Non");
@birthYears = ( 1980 .. 1988 );
@bacYears = ( 'autre', (1990 .. 2001 )); 
@workLoad = ("0h", "<5h", "<10h", "<15h", "<20h", "<30h", ">30h");
@OS = ("Windows 95", "Windows 98", "Windows Me", "Windows 2000", 
       "Windows NT", "Windows XP", "Mac", "MacOS X", "Linux", "autre");
@Origins = ("DEUG MIAS P6", "DEUG SPI P6", "DEUG SCM P6", 
            "autre DEUG MIAS non P6", "autre DEUG non MIAS et non P6", 
            "IUT", "BTS", "CPGE", "autre");
@MIASLanguages = ("Caml", "Java", "Prolog");
@ProgrammingLanguages = ("C", "C++", "C#", "Pascal", "Fortran", "Java",
                         "VisualBasic", "Scheme", "Caml", "Prolog", 
                         "bash", "Perl", "Ruby", "Tcl", "PHP" );
@Connections = ("Non", "modem RTC", "cable", "ADSL", "RNIS");

@OptionsLicence = (
"Industrie informatique et son environnement conomique ",
"Informatique et science du vivant ",
"Programmation des micro-contrleurs industriels ",
"Programmation par objets ",
"Programmation rticulaire ");

# }}}

# {{{ Bag of questions
# Big bag of possible questions.
# This is a hashtable mapping keys (the name of a field in an SQL table)
# to a hashtable describing the question. A question always have
#     a label which is a string asking for an answer, 
#     a kind which may be textfield or menu. This attribute rules how
#            the question will be displayed (and culled).
# Depending on the kind, other attributes are 
#     size that specifies how many columns the textfield should have.
#     choice that specifies the items of the menu.

$bagOfQuestions = {
    'lastName' => 
        {'label' => "Nom", 
         'kind' => 'textfield', 
         'size' => 50},
    'firstName' =>
        {'label' => "Prnom",
         'kind' => 'textfield', 
         'size' => 50},
    # A student ID number at UPMC is made of 7 digits.
    'studentID' =>
        {'label' => "Numro de carte d'tudiant",
         'kind' => 'textfield', 
         'size' => 7,
         'sqltype' => 'int',
         'isValidRegexp' => '\d{7}' },
    'email' =>
        {'label' => "Ml (adresse lectronique si vous en avez une)",
         'kind' => 'textfield',
         'initial' => 'p6lipXXX@infop6.jussieu.fr',
         'size' => 55},
    'login' => {
        'label' => "Nom de connexion (<em>login</em>)",
        'kind' => 'textfield',
        'initial' => 'p6lipXXX',
        'isValidRegexp' => 'p6lip\d\d\d',
        'size' => 10},
    'birthYear' =>
        {'label' => "Anne de naissance",
         'kind' => 'menu',
         'sqltype' => 'int',
         'initial' => '19xx',
         'choice' => \@birthYears},
    'sex' =>
        {'label' => "Sexe",
         'kind' => 'menu',
         'sqltype' => 'char(1)',
         'choice' => \@Sexs},
    'bacYear' =>
        {'label' => "Anne d'obtention du baccalaurat",
         'kind' => 'menu',
         'choice' => \@bacYears},
    'zipCode' =>
        {'label' => "Code postal du domicile",
         'kind' => 'textfield', 
         'size' => 5,
         'sqltype' => 'int',
         'isValidRegexp' => '\d+' },
    'city' =>
        {'label' => "Commune du domicile",
         'kind' => 'textfield', 
         'size' => 55},
    'working' =>
        {'label' => "Exercez-vous une activit salarie",
         'kind' => 'menu',
         'initial' => "Non",
         'choice' => \@YesNo},
    'workDuration' =>
        {'label' => "Si oui, nombre moyen d'heures par semaine",
         'kind' => 'menu',
         'choice' => \@workLoad},
    'commutationDuration' =>
        {'label' => "Temps mis (en moyenne) entre chez vous et l'UPMC 
(aller simple)",
         'kind' => 'menu',
         'choice' => ['<15mn', '<30mn', '<45mn', '<1h', 
                      '<1h30', '<2h', '>=2h']},
    'hasComputer' =>
        {'label' => 
             "Disposez-vous d'un ordinateur pour travailler  votre domicile",
         'kind' => 'menu',
         'choice' => \@YesNo},
    'computerKind' =>
        {'label' => "Type d'ordinateur",
         'kind' => 'checkbox',
         'multiple' => 1,
         'choice' => ['portable', 'de bureau']},
    'osComputer' =>
        {'label' => "Sous quel systme d'exploitation ", 
         'kind' => 'menu', 
         'choice' => \@OS},
    'hasLinux' => {
        'label' => 'Linux est-il install sur votre machine',
        'kind' => 'menu',
        'choice' => \@YesNo},
    'hasPrinter' => 
        {'label' => "Disposez-vous d'une imprimante",
         'kind' => 'menu',          
         'initial' => 'Non',
         'choice' => \@YesNo},
    'hasCDROM' =>
        {'label' => "Disposez-vous d'un lecteur de cdrom",
         'kind' => 'menu',          
         'choice' => \@YesNo},
    'hasInternet' =>
        {'label' => "Disposez-vous d'une connexion  Internet",
         'kind' => 'menu',          
         'initial' => 'Non',
         'choice' => \@YesNo},
    'hasInternetConnection' =>
        {'label' => "Disposez-vous d'une connexion  Internet",
         'kind' => 'menu',          
         'choice' => \@Connections},
    'useWord' =>
        {'label' => "Avez-vous dj utilis un traitement de texte",
         'kind' => 'menu',          
         'choice' => \@YesNo},
    'useInternet' =>
        {'label' => "Vous tes-vous dj connect  Internet",
         'kind' => 'menu', 
         'choice' => \@YesNo},
    'miasP6' => {
        'label' => "tiez-vous l'an dernier en deug mias  Paris 6",
        'kind' => 'menu',
        'choice' => \@YesNo},
    'previousDEUG' => {
        'label' => "O tiez-vous l'an dernier",
        'kind' => 'menu',
        'choice' => \@Origins},
    'optionMiasP6' => {
        'label' => "Langage de l'option d'informatique choisie si MIAS P6",
        'kind' => 'menu',
        'choice' => \@MIASLanguages},
    'knownLanguages' => {
        'label' => "Langages de programmation un peu connus",
        'kind' => 'scroll_plus_other',
        'choice' => \@ProgrammingLanguages},
    'knownLanguagesBeforeMIAS' => {
        'label' => "Langages de programmation connus avant MIAS",
        'kind' => 'scroll_plus_other',
        'choice' => [" - aucun - ", @ProgrammingLanguages]},
    'optionLicence' => {
        'label' => "Option souhaite",
        'kind' => 'menu',
        'choice' => \@OptionsLicence},
};

# }}}

1;

# end of questions.pl
