#! /usr/bin/perl
# Copyright (C) 2001-2002 by <Christian.Queinnec@lip6.fr>
# $Id: sample.cgi,v 1.4 2002/12/27 12:51:46 queinnec Exp $
# Licensed under the same terms as Perl itself.

use CGI qw(:standard :html3);
use CGI::Carp qw(fatalsToBrowser);
require "FOGE.pl";

# Give a choice of a figure between 0 and 9:

my @Figures = ( 0 .. 9);

# Add these questions to the big bag of predefined questions:

FOGE::add_questions({
    'figureAsTiny' => {
        'label'   => "Your preferred figure:",
        'kind'    => 'menu',
        'sqltype' => 'smallint',
        'choice'  => \@Figures},
    'figureAsText' => {
        'label'         => "Your preferred figure:",
        'isValidRegexp' => '^\d$'}, # '$ just for fontlock!
    'understood' => {
        'label'  => "Got it ?", 
        'kind'   => 'menu', 
        'sqltype' => 'boolean', 
        'isValid' => 'coerceToSQLBool', 
        'choice' => \@FOGE::YesNo}, 
    });

# Define the first section of questions as well as whether they are 
# mandatory or not:

my @questions1 = (
    {'id' => 'figureAsTiny'},
    {'mandatory' => 1, 'id' => 'understood'}
);
my $section1 = {
    'title' => "Your preferences", 
    'table' => 'preferred_figures',
    'questions' => \@questions1,
};

# There is no other section here, so we define the whole form:

my @theSections = (
     $section1,
);
$forms = {
    'title'   => "Important poll",
    'css'     => "t.css",
    'author'     => "Christian.Queinnec@lip6.fr",
    'enquiry' => 'sample-poll',
    'introduction' => "This poll tries to figure out what is
the average preferred number.",
    'ipMask'       => '127.0.0.1', # only accepted IP number
    'submit'       => 'VOTE!',
    'acknowledgment' => 'Merci pour votre participation',
    'sets' => \@theSections,
    # SQL data base to be used:
    'dbName'         => 'dbi:Pg:dbname=foge host=localhost',
    'dbWriterName'   => 'fogeuser1',
    'dbWriterPW'     => 'aVerySecretePW',
    'dbReaderName'   => 'fogeuser2',
    'dbReaderPW'     => 'aPublicPW',
    # URL password (Statistics may only be seen if knowing this password):
    'URLpw' => 'anotherSecretePW',
};

# Handle GET or POST requests:
#   http://.../sample.cgi                       will serve the form
#   http://.../sample.cgi/anotherSecretePW/see  will serve the statistics
#   perl ./sample.cgi 'action=genererTablesEnvoyer' > tables.sql
#                      will generate the SQL tables.

FOGE::default_main($forms);

1;

# end of sample.cgi
