#! /usr/bin/perl

use Test;
BEGIN { plan tests => 23 }

# Does FOGE may be required ?
require "FOGE.pl";
ok(defined($FOGE::bagOfQuestions));
ok(defined($FOGE::bagOfQuestions));

# Does sample.cgi may be loaded ?
#require "sample.cgi" || 1;
#ok(defined($FOGE::allQuestionsSets));

# Does sample.cgi may serve a form ?
my $cmd = "perl ./sample.cgi '' > /tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(-s '/tmp/s.html');
my $page = `cat /tmp/s.html`;
ok($page, '/\<html/');
ok($page, '/\<\/html\>/');
ok($page, '/VOTE!/');

# Does sample.cgi may serve a form ?
$cmd = "perl ./sample.cgi 'action=genererTablesEnvoyer' > /tmp/s.sql";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(-s '/tmp/s.sql');
$page = `cat /tmp/s.sql`;
ok($page, '/create table/');
ok($page, '/create table answer/');
ok($page, '/create table preferred_figures/'); # 10

# Create the database:
$cmd = "dropdb foge 2>/dev/null 1>&2";
system($cmd); # Don't croak if error
$cmd = "dropuser fogeuser1 2>/dev/null 1>&2";
system($cmd); # Don't croak if error
$cmd = "dropuser fogeuser2 2>/dev/null 1>&2";
system($cmd); # Don't croak if error
$cmd = "createdb foge";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(1);
$cmd = "psql foge -f /tmp/s.sql";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(1);

# Register answer 1:
$parms = "'action=VOTE!&figureAsTiny=1&understood=Oui'";
$cmd = "perl ./sample.cgi $parms >/tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
$page = `cat /tmp/s.html`;
ok($page, '/Merci pour votre participation/');

# Register answer 2:
$parms = "'action=VOTE!&figureAsTiny=2&understood=Oui'";
$cmd = "sleep 1; perl ./sample.cgi $parms >/tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
$page = `cat /tmp/s.html`;
ok($page, '/Merci pour votre participation/');

# Register answer 3: the understood field is missing
$parms = "'action=VOTE!&figureAsTiny=1'";
$cmd = "sleep 1; perl ./sample.cgi $parms >/tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
$page = `cat /tmp/s.html`;
ok($page, '/la question . Got it /'); # 15

# Register answer 4: the figureAsTiny may miss
$parms = "'action=VOTE!&understood=Oui'";
$cmd = "sleep 1; perl ./sample.cgi $parms >/tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
$page = `cat /tmp/s.html`;
ok($page, '/Merci pour votre participation/');

# Check tables:
$parms = "'action=verifierTables'";
$cmd = "perl ./sample.cgi $parms >/tmp/s.html";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(-s '/tmp/s.html');
$page = `cat /tmp/s.html`;
ok($page, '/\<html/');
ok($page, '/\<\/html\>/');
ok($page, '/There are 3 records in table answer/');

# Cull answers: HOW TO TEST ?
#FOGE::compute_statistics(2001, 30, $FOGE::allQuestionsSets);

# Clean database:
$cmd = "dropdb foge";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(1);
$cmd = "dropuser fogeuser1";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(1);
$cmd = "dropuser fogeuser2";
system($cmd);
croak("Cannot run $cmd") if $? != 0;
ok(1);

# end of serveForm.t
